summaryrefslogtreecommitdiffstats
path: root/cryptopp
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2018-04-13 22:44:42 +0000
committer Eric Hameleers <alien@slackware.com>2018-04-13 22:44:42 +0000
commitd2075a0ff9bee01964ac03767cb1bf64cb94e1b1 (patch)
tree297c8ea575a54a8c76e06b3db7f8cb15d06cc9cc /cryptopp
parent7955be53831a698eca6f9f4fe5e74d9a614e0b62 (diff)
downloadasb-d2075a0ff9bee01964ac03767cb1bf64cb94e1b1.tar.gz
asb-d2075a0ff9bee01964ac03767cb1bf64cb94e1b1.tar.xz
cryptopp: updated to 6.0.0 using the 'ktown' SlackBuild script
Diffstat (limited to 'cryptopp')
-rwxr-xr-xcryptopp/build/cryptopp.SlackBuild219
1 files changed, 65 insertions, 154 deletions
diff --git a/cryptopp/build/cryptopp.SlackBuild b/cryptopp/build/cryptopp.SlackBuild
index 4116b3f3..ea314586 100755
--- a/cryptopp/build/cryptopp.SlackBuild
+++ b/cryptopp/build/cryptopp.SlackBuild
@@ -1,6 +1,7 @@
#!/bin/sh
-# $Id$
-# Copyright 2014 Eric Hameleers, Eindhoven, NL
+
+# Copyright 2014, 2018 Eric Hameleers, Eindhoven, NL
+# Copyright 2018 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software for
@@ -21,173 +22,90 @@
# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
# -----------------------------------------------------------------------------
-#
-# Slackware SlackBuild script
-# ===========================
-# By: Eric Hameleers <alien@slackware.com>
-# For: cryptopp
-# Descr: library of cryptographic schemes
-# URL: http://www.cryptopp.com/
-# Build needs:
-# Needs:
-# Changelog:
-# 5.6.2-1: 16/Mar/2014 by Eric Hameleers <alien@slackware.com>
-# * Initial build.
-#
-# Run 'sh cryptopp.SlackBuild' to build a Slackware package.
-# The package (.tgz) and .txt file as well as build logs are created in /tmp .
-# Install it using 'installpkg'.
-#
-# -----------------------------------------------------------------------------
-
-PRGNAM=cryptopp
-VERSION=${VERSION:-5.6.2}
-SRCVER=$(echo $VERSION | tr -d '.')
-BUILD=${BUILD:-1}
-NUMJOBS=${NUMJOBS:" -j4 "}
-TAG=${TAG:-alien}
-
-DOCS="License.txt Readme.txt"
-
-# Where do we look for sources?
-SRCDIR=$(cd $(dirname $0); pwd)
-# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
-TMP=${TMP:-/tmp/build}
-PKG=$TMP/package-$PRGNAM
-OUTPUT=${OUTPUT:-/tmp}
-SOURCE="$SRCDIR/${PRGNAM}${SRCVER}.zip"
-SRCURL="http://www.cryptopp.com/${PRGNAM}${SRCVER}.zip"
+PKGNAM=cryptopp
+VERSION=${VERSION:-6.0.0}
+SRCVER=$(echo $VERSION | tr -d '.')
+BUILD=${BUILD:-2}
+NUMJOBS=${NUMJOBS:--j7}
-##
-## --- with a little luck, you won't have to edit below this point --- ##
-##
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-$PKGNAM
# Automatically determine the architecture we're building on:
-MARCH=$( uname -m )
if [ -z "$ARCH" ]; then
- case "$MARCH" in
- i?86) export ARCH=i486 ;;
- armv7hl) export ARCH=$MARCH ;;
- armv6hl) export ARCH=$MARCH ;;
- arm*) export ARCH=arm ;;
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
# Unless $ARCH is already set, use uname -m for all other archs:
- *) export ARCH=$MARCH ;;
+ *) ARCH=$(uname -m) ;;
esac
+ export ARCH
fi
-case "$ARCH" in
- i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
- SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ;;
- x86_64) SLKCFLAGS="-O2 -fPIC"
- SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
- ;;
- armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
- SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ;;
- armv6hl) SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard"
- SLKLDFLAGS=""; LIBDIRSUFFIX=""
- ;;
- *) SLKCFLAGS=${SLKCFLAGS:-"O2"}
- SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
- ;;
-esac
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ SLKLDFLAGS=""
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "armv7hl" ]; then
+ SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""
+ LIBDIRSUFFIX=""
+else
+ SLKCFLAGS="-O2"
+ SLKLDFLAGS=""
+ LIBDIRSUFFIX=""
+fi
case "$ARCH" in
- arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
- *) TARGET=$ARCH-slackware-linux ;;
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
esac
-# Exit the script on errors:
-set -e
-trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
-# Catch unitialized variables:
-set -u
-P1=${1:-1}
-
-# Save old umask and set to 0022:
-_UMASK_=$(umask)
-umask 0022
-
-# Create working directories:
-mkdir -p $OUTPUT # place for the package to be saved
-mkdir -p $TMP/tmp-$PRGNAM # location to build the source
-mkdir -p $PKG # place for the package to be built
-rm -rf $PKG/* # always erase old package's contents
-rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
-rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
- # remove old log files
-
-# Source file availability:
-if ! [ -f ${SOURCE} ]; then
- echo "Source '$(basename ${SOURCE})' not available yet..."
- # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
- [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
- if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
- if ! [ "x${SRCURL}" == "x" ]; then
- echo "Will download file to $(dirname $SOURCE)"
- wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
- if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
- echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
- mv -f "${SOURCE}" "${SOURCE}".FAIL
- exit 1
- fi
- else
- echo "File '$(basename ${SOURCE})' not available... aborting the build."
- exit 1
- fi
-fi
-
-if [ "$P1" == "--download" ]; then
- echo "Download complete."
- exit 0
-fi
+# Extract the sources:
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf ${PKGNAM}-${VERSION}
+mkdir -p ${PKGNAM}-${VERSION}
+unzip -a ${CWD}/${PKGNAM}${SRCVER}.zip -d ${PKGNAM}-${VERSION} || exit 1
+cd ${PKGNAM}-${VERSION} || exit 1
-# --- PACKAGE BUILDING ---
+## Do not mess up the CXXFLAGS:
+#cat $CWD/patches/cryptopp_slkcflags.patch | patch -p1 --verbose || exit 1
-echo "++"
-echo "|| $PRGNAM-$VERSION"
-echo "++"
-
-cd $TMP/tmp-$PRGNAM
-mkdir -p ${PRGNAM}-${VERSION}
-unzip ${SOURCE} -d ${PRGNAM}-${VERSION}
-cd ${PRGNAM}-${VERSION}
+# Fix bogus permissions:
chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
-# Do not mess up the CXXFLAGS:
-cat $SRCDIR/cryptopp_slkcflags.patch | patch -p1 --verbose \
- 2>&1 | tee $OUTPUT/patch-${PRGNAM}.log
-
-chmod -R u+w,go+r-w,a+rX-st .
-
-echo Building ...
-export LDFLAGS="$SLKLDFLAGS"
-export CXXFLAGS="$SLKCFLAGS"
-export CFLAGS="$SLKCFLAGS"
-
-# Care for 64-bit Slackware:
+# Cater to 64-bit Slackware:
sed -i -e "s,(PREFIX)/lib,(PREFIX)/lib${LIBDIRSUFFIX},g" GNUmakefile
-make $NUMJOBS CXXFLAGS="${CXXFLAGS}" LDFLAGS="${LDFLAGS}" dynamic static \
- 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
-make PREFIX=$PKG/usr install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+# Compile and install:
+make dynamic $NUMJOBS \
+ CXXFLAGS="${SLKCFLAGS} -DNDEBUG" LDFLAGS="${LDFLAGS}"
+make install PREFIX=$PKG/usr
-# Install the pkg-config file:
-install -D -m644 $SRCDIR/${PRGNAM}.pc \
- $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig/cryptopp.pc
-sed -e "s,@LIBDIRSUFFIX@,${LIBDIRSUFFIX},g" \
+# Install a pkg-config file:
+mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig
+cat $CWD/${PKGNAM}.pc | sed \
+ -e "s,@LIBDIRSUFFIX@,${LIBDIRSUFFIX},g" \
-e "s,@VERSION@,${VERSION},g" \
- -i $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig/cryptopp.pc
+ > $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig/cryptopp.pc
# Add documentation:
-mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
-cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
-chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
-find $PKG/usr/doc -type f -exec chmod 644 {} \;
+mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
+cp -a *.txt $PKG/usr/doc/$PKGNAM-$VERSION
# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
@@ -195,16 +113,9 @@ find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
# Add a package description:
mkdir -p $PKG/install
-cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $CWD/slack-desc > $PKG/install/slack-desc
# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
-cd $OUTPUT
-md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
-cd -
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
-
-# Restore the original umask:
-umask ${_UMASK_}
+/sbin/makepkg -l y -c n $TMP/${PKGNAM}-${VERSION}-${ARCH}-${BUILD}.txz